## ros-kinetic-tuw-ellipses 0.0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(tuw_ellipses)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  cv_bridge
  dynamic_reconfigure
  image_transport
  image_geometry
  geometry_msgs
  roscpp
  rospy
  tf
  nodelet
  marker_msgs
)

## System dependencies are found with CMake's conventions
# find_package(Boost REQUIRED COMPONENTS system)
find_package( OpenCV REQUIRED )
link_libraries(${OpenCV_LIBS})

#find_package(cmake_modules REQUIRED)

find_package(Eigen3 REQUIRED)
include_directories(${Eigen_INCLUDE_DIRS})


#add dynamic reconfigure api
generate_dynamic_reconfigure_options(
  cfg/EllipsesDetection.cfg
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES tuw_ellipses
#  CATKIN_DEPENDS cv_bridge dynamic_reconfigure image_geometry image_transport roscpp rospy tf
#  DEPENDS eigen3 OpenCV
)

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(include)
include_directories(
  ${catkin_INCLUDE_DIRS}
)

add_library(tuw_utils 
   src/tuw_utils/contour.cpp 
   src/tuw_utils/canny.cpp
   src/tuw_utils/camera.cpp
   src/tuw_utils/ellipse_refinement.cpp
)

## Declare a cpp library
add_library(ellipses
   src/${PROJECT_NAME}/ellipses_detection.cpp
   src/${PROJECT_NAME}/ellipses_draw.cpp
   src/${PROJECT_NAME}/ellipses_parameters.cpp
)

add_library(ellipses_nodelet
   src/ellipses_nodelet.cpp
   src/ellipses_nodelet_parameters.cpp
)

## Declare a cpp executable
add_executable(ellipses_node src/ellipses_node.cpp)

## Add cmake target dependencies of the executable/library
## as an example, message headers may need to be generated before nodes
# add_dependencies(tuw_ellipses_node tuw_ellipses_generate_messages_cpp)
add_dependencies(ellipses_nodelet ${PROJECT_NAME}_gencfg) 
# add_dependencies(ellipses_nodelet ${PROJECT_NAME}_gencpp)

## Specify libraries to link a library or executable target against
target_link_libraries(ellipses_nodelet
   ellipses tuw_utils ${catkin_LIBRARIES}
)
target_link_libraries(ellipses_node
   ellipses_nodelet ${catkin_LIBRARIES}
)
#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executable scripts (Python etc.) for installation
## in contrast to setup.py, you can choose the destination
# install(PROGRAMS
#   scripts/my_python_script
#   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark executables and/or libraries for installation
# install(TARGETS tuw_aruco tuw_aruco_node
#   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
#   RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
# )

## Mark cpp header files for installation
#install(DIRECTORY include/${PROJECT_NAME}/
#  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
#  FILES_MATCHING PATTERN "*.h"
#  PATTERN ".svn" EXCLUDE
#)

## Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)
install(DIRECTORY bags/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/bags
)

=== src/tuw_utils/CMakeLists.txt ===

add_subdirectory(example)

=== src/tuw_utils/example/CMakeLists.txt ===

add_executable(contour main_contour.cpp)
target_link_libraries(contour ${OPENCV_LIBRARIES}  tuw_contour)


add_executable(edgelinker main_edgelinker.cpp)
target_link_libraries(edgelinker ${OPENCV_LIBRARIES}  tuw_edgelinker tuw_canny)

=== debian/changelog ===
ros-kinetic-tuw-ellipses (0.0.7-0xenial) xenial; urgency=high

  * Added eigen as build dependency to tuw_ellipses
  * Contributors: Markus Bader

 -- Markus Bader <markus.bader@tuwien.ac.at>  Sat, 12 Nov 2016 23:00:00 -0000

ros-kinetic-tuw-ellipses (0.0.6-0xenial) xenial; urgency=high

  * image_geometry was missing in package.xml
  * Contributors: Markus Bader

 -- Markus Bader <markus.bader@tuwien.ac.at>  Fri, 11 Nov 2016 23:00:00 -0000

ros-kinetic-tuw-ellipses (0.0.5-0xenial) xenial; urgency=high

  * DynamicReconfigure files naming fixed
  * Contributors: Markus Bader

 -- Markus Bader <markus.bader@tuwien.ac.at>  Thu, 10 Nov 2016 23:00:00 -0000

ros-kinetic-tuw-ellipses (0.0.4-0xenial) xenial; urgency=high

  * dynamic reconfiger compile order fixed for ellipses_nodelet
  * Contributors: Markus Bader

 -- Markus Bader <markus.bader@tuwien.ac.at>  Thu, 10 Nov 2016 23:00:00 -0000

ros-kinetic-tuw-ellipses (0.0.3-0xenial) xenial; urgency=high

  * cmake_modules to package xml added
  * flags added to eaktivate publishing
  * ellipses are publishing marker_msgs
  * minor changes to fix jenkins build error
  * Contributors: Markus Bader

 -- Markus Bader <markus.bader@tuwien.ac.at>  Thu, 10 Nov 2016 23:00:00 -0000

ros-kinetic-tuw-ellipses (0.0.2-0xenial) xenial; urgency=high

  * Initial commit
  * Contributors: Markus Bader, Lukas Pfeifhofer

 -- Markus Bader <markus.bader@tuwien.ac.at>  Sun, 06 Nov 2016 23:00:00 -0000

=== debian/control ===
Source: ros-kinetic-tuw-ellipses
Section: misc
Priority: extra
Maintainer: Markus Bader <markus.bader@tuwien.ac.at>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-marker-msgs, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-tuw-ellipses
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-marker-msgs, ros-kinetic-nodelet, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-tf
Description: The tuw_ellipses package contains a computer vision library which is able to detect ellipses within images.
 The package is able to estimate the pose of the circle related to the ellipse the circle diameter as well as the camera parameter are known. A dynamic reconfigure interface allows the user to tune the parameter of the system to ones needs. But be aware that the pose of a projected circle within a image (ellipse) has two solutions and only one is published as TF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-tuw-ellipses//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
